[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 1. Introduction

FFmpeg is a very fast video and audio converter. It can also grab from a live audio/video source.

The command line interface is designed to be intuitive, in the sense that ffmpeg tries to figure out all the parameters, when possible. You have usually to give only the target bitrate you want.

FFmpeg can also convert from any sample rate to any other, and resize video on the fly with a high quality polyphase filter.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 2. Quick Start

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 2.1 Video and Audio grabbing

FFmpeg can use a video4linux compatible video source and any Open Sound System audio source:

    ffmpeg /tmp/out.mpg

Note that you must activate the right video source and channel before launching ffmpeg. You can use any TV viewer such as xawtv (http://bytesex.org/xawtv/) by Gerd Knorr which I find very good. You must also set correctly the audio recording levels with a standard mixer.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 2.2 Video and Audio file format conversion

* ffmpeg can use any supported file format and protocol as input:

Examples:

* You can input from YUV files:

    ffmpeg -i /tmp/test%d.Y /tmp/out.mpg

It will use the files:

    /tmp/test0.Y, /tmp/test0.U, /tmp/test0.V,
    /tmp/test1.Y, /tmp/test1.U, /tmp/test1.V, etc...

The Y files use twice the resolution of the U and V files. They are raw files, without header. They can be generated by all decent video decoders. You must specify the size of the image with the ``-s'` option if ffmpeg cannot guess it.

* You can input from a RAW YUV420P file:

    ffmpeg -i /tmp/test.yuv /tmp/out.avi

The RAW YUV420P is a file containing RAW YUV planar, for each frame first come the Y plane followed by U and V planes, which are half vertical and horizontal resolution.

* You can output to a RAW YUV420P file:

    ffmpeg -i mydivx.avi -o hugefile.yuv

* You can set several input files and output files:

    ffmpeg -i /tmp/a.wav -s 640x480 -i /tmp/a.yuv /tmp/a.mpg

Convert the audio file a.wav and the raw yuv video file a.yuv to mpeg file a.mpg

* You can also do audio and video conversions at the same time:

    ffmpeg -i /tmp/a.wav -ar 22050 /tmp/a.mp2

Convert the sample rate of a.wav to 22050 Hz and encode it to MPEG audio.

* You can encode to several formats at the same time and define a mapping from input stream to output streams:

    ffmpeg -i /tmp/a.wav -ab 64 /tmp/a.mp2 -ab 128 /tmp/b.mp2 -map 0:0 -map 0:0

Convert a.wav to a.mp2 at 64 kbits and b.mp2 at 128 kbits. '-map file:index' specify which input stream is used for each output stream, in the order of the definition of output streams.

* You can transcode decrypted VOBs

    ffmpeg -i snatch_1.vob -f avi -vcodec mpeg4 -b 800 -g 300 -bf 2 -acodec mp3 -ab 128 snatch.avi

This is a typical DVD ripper example, input from a VOB file, output to an AVI file with MPEG-4 video and MP3 audio, note that in this command we use B frames so the MPEG-4 stream is DivX5 compatible, GOP size is 300 that means an INTRA frame every 10 seconds for 29.97 fps input video. Also the audio stream is MP3 encoded so you need LAME support which is enabled using `--enable-mp3lame` when configuring. The mapping is particularly useful for DVD transcoding to get the desired audio language.

NOTE: to see the supported input formats, use `ffmpeg -formats`.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 3. Invocation

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.1 Syntax

The generic syntax is:

    ffmpeg [[options][`-i' input_file]]... {[options] output_file}...

If no input file is given, audio/video grabbing is done.

As a general rule, options are applied to the next specified file. For example, if you give the ``-b 64'` option, it sets the video bitrate of the next file. Format option may be needed for raw input files.

By default, ffmpeg tries to convert as losslessly as possible: it uses the same audio and video parameter for the outputs as the one specified for the inputs.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.2 Main options

``-L'`

  show license

``-h'`

  show help

``-formats'`

  show available formats, codecs, protocols, ...

``-f fmt'`

  force format

``-i filename'`

  input file name

``-y'`

  overwrite output files

``-t duration'`

  set the recording time in seconds. `hh:mm:ss[.xxx]` syntax is also supported.

``-ss position'`

  seek to given time position. `hh:mm:ss[.xxx]` syntax is also supported.

``-title string'`

  set the title

``-author string'`

  set the author

``-copyright string'`

  set the copyright

``-comment string'`

  set the comment

``-target type'`

  specify target file type ("vcd", "svcd" or "dvd"). All the format options (bitrate, codecs, buffer sizes) are automatically set by this option. You can just type:

      ffmpeg -i myfile.avi -target vcd /tmp/vcd.mpg

``-hq'`

  activate high quality settings

``-itsoffset offset'`

  set the input time offset in seconds. `[-]hh:mm:ss[.xxx]` syntax is also supported. This option affects all the input files that follow it. The offset is added to the input files' timestamps; specifying a positive offset means that the corresponding streams are delayed by 'offset' seconds.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.3 Video Options

``-b bitrate'`

  set the video bitrate in kbit/s (default = 200 kb/s)

``-r fps'`

  set frame rate (default = 25)

``-s size'`

  set frame size. The format is ``WxH'` (default 160x128). The following abbreviations are recognized:

  ``sqcif'`

    128x96

  ``qcif'`

    176x144

  ``cif'`

    352x288

  ``4cif'`

    704x576

``-aspect aspect'`

  set aspect ratio (4:3, 16:9 or 1.3333, 1.7777)

``-croptop size'`

  set top crop band size (in pixels)

``-cropbottom size'`

  set bottom crop band size (in pixels)

``-cropleft size'`

  set left crop band size (in pixels)

``-cropright size'`

  set right crop band size (in pixels)

``-padtop size'`

  set top pad band size (in pixels)

``-padbottom size'`

  set bottom pad band size (in pixels)

``-padleft size'`

  set left pad band size (in pixels)

``-padright size'`

  set right pad band size (in pixels)

``-padcolor color'`

  set right pad band size (hex). The value for pad color is expressed as a six digit hexidecimal number where the first two digits represent red, middle two digits green and last two digits blue. Defaults to 000000 (black)

``-vn'`

  disable video recording

``-bt tolerance'`

  set video bitrate tolerance (in kbit/s)

``-maxrate bitrate'`

  set max video bitrate tolerance (in kbit/s)

``-minrate bitrate'`

  set min video bitrate tolerance (in kbit/s)

``-bufsize size'`

  set ratecontrol buffere size (in kbit)

``-vcodec codec'`

  force video codec to codec. Use the `copy` special value to tell that the raw codec data must be copied as is.

``-sameq'`

  use same video quality as source (implies VBR)

``-pass n'`

  select the pass number (1 or 2). It is useful to do two pass encoding. The statistics of the video are recorded in the first pass and the video at the exact requested bit rate is generated in the second pass.

``-passlogfile file'`

  select two pass log file name to file.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.4 Advanced Video Options

``-g gop_size'`

  set the group of picture size

``-intra'`

  use only intra frames

``-qscale q'`

  use fixed video quantiser scale (VBR)

``-qmin q'`

  min video quantiser scale (VBR)

``-qmax q'`

  max video quantiser scale (VBR)

``-qdiff q'`

  max difference between the quantiser scale (VBR)

``-qblur blur'`

  video quantiser scale blur (VBR)

``-qcomp compression'`

  video quantiser scale compression (VBR)

``-rc_init_cplx complexity'`

  initial complexity for 1-pass encoding

``-b_qfactor factor'`

  qp factor between p and b frames

``-i_qfactor factor'`

  qp factor between p and i frames

``-b_qoffset offset'`

  qp offset between p and b frames

``-i_qoffset offset'`

  qp offset between p and i frames

``-rc_eq equation'`

  set rate control equation (see section FFmpeg formula evaluator). Default is `tex^qComp`.

``-rc_override override'`

  rate control override for specific intervals

``-me method'`

  set motion estimation method to method. Available methods are (from lower to best quality):

  ``zero'`

    Try just the (0, 0) vector.

  ``phods'`
  ``log'`
  ``x1'`
  ``epzs'`

    (default method)

  ``full'`

    exhaustive search (slow and marginally better than epzs)

``-dct_algo algo'`

  set dct algorithm to algo. Available values are:

  ``0'`

    FF_DCT_AUTO (default)

  ``1'`

    FF_DCT_FASTINT

  ``2'`

    FF_DCT_INT

  ``3'`

    FF_DCT_MMX

  ``4'`

    FF_DCT_MLIB

  ``5'`

    FF_DCT_ALTIVEC

``-idct_algo algo'`

  set idct algorithm to algo. Available values are:

  ``0'`

    FF_IDCT_AUTO (default)

  ``1'`

    FF_IDCT_INT

  ``2'`

    FF_IDCT_SIMPLE

  ``3'`

    FF_IDCT_SIMPLEMMX

  ``4'`

    FF_IDCT_LIBMPEG2MMX

  ``5'`

    FF_IDCT_PS2

  ``6'`

    FF_IDCT_MLIB

  ``7'`

    FF_IDCT_ARM

  ``8'`

    FF_IDCT_ALTIVEC

  ``9'`

    FF_IDCT_SH4

  ``10'`

    FF_IDCT_SIMPLEARM

``-er n'`

  set error resilience to n.

  ``1'`

    FF_ER_CAREFULL (default)

  ``2'`

    FF_ER_COMPLIANT

  ``3'`

    FF_ER_AGGRESSIVE

  ``4'`

    FF_ER_VERY_AGGRESSIVE

``-ec bit_mask'`

  set error concealment to bit_mask. bit_mask is a bit mask of the following values:

  ``1'`

    FF_EC_GUESS_MVS (default=enabled)

  ``2'`

    FF_EC_DEBLOCK (default=enabled)

``-bf frames'`

  use 'frames' B frames (supported for MPEG-1, MPEG-2 and MPEG-4)

``-mbd mode'`

  macroblock decision

  ``0'`

    FF_MB_DECISION_SIMPLE: use mb_cmp (cannot change it yet in ffmpeg)

  ``1'`

    FF_MB_DECISION_BITS: chooses the one which needs the fewest bits

  ``2'`

    FF_MB_DECISION_RD: rate distoration

``-4mv'`

  use four motion vector by macroblock (only MPEG-4)

``-part'`

  use data partitioning (only MPEG-4)

``-bug param'`

  workaround not auto detected encoder bugs

``-strict strictness'`

  how strictly to follow the standarts

``-aic'`

  enable Advanced intra coding (h263+)

``-umv'`

  enable Unlimited Motion Vector (h263+)

``-deinterlace'`

  deinterlace pictures

``-interlace'`

  force interlacing support in encoder (only MPEG-2 and MPEG-4). Use this option if your input file is interlaced and if you want to keep the interlaced format for minimum losses. The alternative is to deinterlace the input stream with ``-deinterlace'`, but deinterlacing introduces more losses.

``-psnr'`

  calculate PSNR of compressed frames

``-vstats'`

  dump video coding statistics to ``vstats_HHMMSS.log'`.

``-vhook module'`

  insert video processing module. module contains the module name and its parameters separated by spaces.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.5 Audio Options

``-ab bitrate'`

  set audio bitrate (in kbit/s)

``-ar freq'`

  set the audio sampling freq (default = 44100 Hz)

``-ab bitrate'`

  set the audio bitrate in kbit/s (default = 64)

``-ac channels'`

  set the number of audio channels (default = 1)

``-an'`

  disable audio recording

``-acodec codec'`

  force audio codec to codec. Use the `copy` special value to tell that the raw codec data must be copied as is.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.6 Audio/Video grab options

``-vd device'`

  set video grab device (e.g. ``/dev/video0'`)

``-vc channel'`

  set video grab channel (DV1394 only)

``-tvstd standard'`

  set television standard (NTSC, PAL (SECAM))

``-dv1394'`

  set DV1394 grab

``-ad device'`

  set audio device (e.g. ``/dev/dsp'`)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.7 Advanced options

``-map file:stream'`

  set input stream mapping

``-debug'`

  print specific debug info

``-benchmark'`

  add timings for benchmarking

``-hex'`

  dump each input packet

``-bitexact'`

  only use bit exact algorithms (for codec testing)

``-ps size'`

  set packet size in bits

``-re'`

  read input at native frame rate. Mainly used to simulate a grab device.

``-loop'`

  loop over the input stream. Currently it works only for image streams. This option is used for ffserver automatic testing.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.8 FFmpeg formula evaluator

When evaluating a rate control string, FFmpeg uses an internal formula evaluator.

The following binary operators are available: `+`, `-`, `*`, `/`, `^`.

The following unary operators are available: `+`, `-`, `(...)`.

The following functions are available:

sinh(x)
cosh(x)
tanh(x)
sin(x)
cos(x)
tan(x)
exp(x)
log(x)
squish(x)
gauss(x)
abs(x)
max(x, y)
min(x, y)
gt(x, y)
lt(x, y)
eq(x, y)
bits2qp(bits)
qp2bits(qp)

The following constants are available:

PI
E
iTex
pTex
tex
mv
fCode
iCount
mcVar
var
isI
isP
isB
avgQP
qComp
avgIITex
avgPITex
avgPPTex
avgBPTex
avgTex

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.9 Protocols

The filename can be ``-'` to read from the standard input or to write to the standard output.

ffmpeg handles also many protocols specified with the URL syntax.

Use 'ffmpeg -formats' to have a list of the supported protocols.

The protocol `http:` is currently used only to communicate with ffserver (see the ffserver documentation). When ffmpeg will be a video player it will also be used for streaming :-)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 4. Tips

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 5. Supported File Formats and Codecs

You can use the `-formats` option to have an exhaustive list.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.1 File Formats

FFmpeg supports the following file formats through the `libavformat` library:

Supported File Format | Encoding | Decoding
MPEG audio | X | X
MPEG1 systems | X | X
MPEG2 PS | X | X
MPEG2 TS |  | X
ASF | X | X
AVI | X | X
WAV | X | X
Macromedia Flash | X | X
FLV | X | X
Real Audio and Video | X | X
Raw AC3 | X | X
Raw MJPEG | X | X
Raw MPEG video | X | X
Raw PCM8/16 bits, mulaw/Alaw | X | X
Raw CRI ADX audio | X | X
SUN AU format | X | X
NUT | X | X
Quicktime | X | X
MPEG4 | X | X
Raw MPEG4 video | X | X
DV | X | X
4xm |  | X
Playstation STR |  | X
Id RoQ |  | X
Interplay MVE |  | X
WC3 Movie |  | X
Sega FILM/CPK |  | X
Westwood Studios VQA/AUD |  | X
Id Cinematic (.cin) |  | X
FLIC format |  | X
Sierra VMD |  | X
Matroska |  | X

`X` means that the encoding (resp. decoding) is supported.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.2 Image Formats

FFmpeg can read and write images for each frame of a video sequence. The following image formats are supported:

Supported Image Format | Encoding | Decoding
PGM, PPM | X | X
PAM | X | X
PGMYUV | X | X
JPEG | X | X
.Y.U.V | X | X
Animated GIF | X | X
PNG | X | X
SGI | X | X

`X` means that the encoding (resp. decoding) is supported.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.3 Video Codecs

Supported Codec | Encoding | Decoding | Comments
MPEG1 video | X | X
MPEG2 video | X | X
MPEG4 | X | X | Also known as DIVX4/5
MSMPEG4 V1 | X | X
MSMPEG4 V2 | X | X
MSMPEG4 V3 | X | X | Also known as DIVX3
WMV7 | X | X
WMV8 | X | X | Not completely working
H263(+) | X | X | Also known as Real Video 1.0
MJPEG | X | X
Lossless MJPEG | X | X
Apple MJPEG-B |  | X
Sunplus MJPEG |  | X | fourcc: SP5X
DV | X | X
Huff YUV | X | X
FFmpeg Video 1 | X | X | Lossless codec (fourcc: FFV1)
Asus v1 | X | X | fourcc: ASV1
Asus v2 | X | X | fourcc: ASV2
Creative YUV |  | X | fourcc: CYUV
H.264 |  | X
Sorenson Video 1 | X | X | fourcc: SVQ1
Sorenson Video 3 |  | X | fourcc: SVQ3
On2 VP3 |  | X | still experimental
Theora |  | X | still experimental
Intel Indeo 3 |  | X | only works on i386 right now
FLV | X | X | Flash H263 variant
ATI VCR1 |  | X | fourcc: VCR1
ATI VCR2 |  | X | fourcc: VCR2
Cirrus Logic AccuPak |  | X | fourcc: CLJR
4X Video |  | X | used in certain computer games
Sony Playstation MDEC |  | X
Id RoQ |  | X | used in Quake III, Jedi Knight 2, other computer games
Xan/WC3 |  | X | used in Wing Commander III .MVE files
Interplay Video |  | X | used in Interplay .MVE files
Apple Animation |  | X | fourcc: 'rle '
Apple Graphics |  | X | fourcc: 'smc '
Apple Video |  | X | fourcc: rpza
Cinepak |  | X
Microsoft RLE |  | X
Microsoft Video-1 |  | X
Westwood VQA |  | X
Id Cinematic Video |  | X | used in Quake II
Planar RGB |  | X | fourcc: 8BPS
FLIC video |  | X
Duck TrueMotion v1 |  | X | fourcc: DUCK
VMD Video |  | X | used in Sierra VMD files
MSZH |  | X | Part of LCL
ZLIB | X | X | Part of LCL, encoder experimental

`X` means that the encoding (resp. decoding) is supported.

Check at http://www.mplayerhq.hu/~michael/codec-features.html to get a precise comparison of FFmpeg MPEG4 codec compared to the other solutions.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.4 Audio Codecs

Supported Codec | Encoding | Decoding | Comments
MPEG audio layer 2 | IX | IX
MPEG audio layer 1/3 | IX | IX | MP3 encoding is supported through the external library LAME
AC3 | IX | X | liba52 is used internally for decoding
Vorbis | X | X | supported through the external library libvorbis
WMA V1/V2 |  | X
AAC | X | X | supported through the external library libfaac/libfaad
Microsoft ADPCM | X | X
MS IMA ADPCM | X | X
QT IMA ADPCM |  | X
4X IMA ADPCM |  | X
G.726 ADPCM | X | X
Duck DK3 IMA ADPCM |  | X | used in some Sega Saturn console games
Duck DK4 IMA ADPCM |  | X | used in some Sega Saturn console games
Westwood Studios IMA ADPCM |  | X | used in Westwood Studios games like Command and Conquer
SMJPEG IMA ADPCM |  | X | used in certain Loki game ports
CD-ROM XA ADPCM |  | X
CRI ADX ADPCM | X | X | used in Sega Dreamcast games
Electronic Arts ADPCM |  | X | used in various EA titles
RA144 |  | X | Real 14400 bit/s codec
RA288 |  | X | Real 28800 bit/s codec
AMR-NB | X | X | supported through an external library
AMR-WB | X | X | supported through an external library
DV audio |  | X
Id RoQ DPCM |  | X | used in Quake III, Jedi Knight 2, other computer games
Interplay MVE DPCM |  | X | used in various Interplay computer games
Xan DPCM |  | X | used in Origin's Wing Commander IV AVI files
Apple MACE 3 |  | X
Apple MACE 6 |  | X
FLAC |  | X

`X` means that the encoding (resp. decoding) is supported.

`I` means that an integer only version is available too (ensures highest performances on systems without hardware floating point support).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 6. Platform Specific information

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.1 Linux

ffmpeg should be compiled with at least GCC 2.95.3. GCC 3.2 is the preferred compiler now for ffmpeg. All future optimizations will depend on features only found in GCC 3.2.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.2 BSD

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.3 Windows

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 6.3.1 Native Windows compilation

Notes:

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 6.3.2 Cross compilation for Windows with Linux

You must use the MinGW cross compilation tools available at http://www.mingw.org/.

Then configure ffmpeg with the following options:

    ./configure --enable-mingw32 --cross-prefix=i386-mingw32msvc-

(you can change the cross-prefix according to the prefix choosen for the MinGW tools).

Then you can easily test ffmpeg with wine (http://www.winehq.com/).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.4 MacOS X

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.5 BeOS

The configure script should guess the configuration itself. Networking support is currently not finished. errno issues fixed by Andrew Bachmann.

Old stuff:

François Revol - revol at free dot fr - April 2002

The configure script should guess the configuration itself, however I still didn't tested building on net_server version of BeOS.

ffserver is broken (needs poll() implementation).

There is still issues with errno codes, which are negative in BeOs, and that ffmpeg negates when returning. This ends up turning errors into valid results, then crashes. (To be fixed)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 7. Developers Guide

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.1 API

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.2 Integrating libavcodec or libavformat in your program

You can integrate all the source code of the libraries to link them statically to avoid any version problem. All you need is to provide a 'config.mak' and a 'config.h' in the parent directory. See the defines generated by ./configure to understand what is needed.

You can use libavcodec or libavformat in your commercial program, but any patch you make must be published. The best way to proceed is to send your patches to the ffmpeg mailing list.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.3 Coding Rules

ffmpeg is programmed in the ISO C90 language with a few additional features from ISO C99, namely:

- the ``inline'` keyword;
- ``//'` comments;
- designated struct initializers (``struct s x = { .i = 17 };'`)
- compound literals (``x = (struct s) { 17, 23 };'`)

These features are supported by all compilers we care about, so we won't accept patches to remove their use unless they absolutely don't impair clarity and performance.

All code must compile with gcc 2.95 and gcc 3.3. Currently, ffmpeg also compiles with several other compilers, such as the Compaq ccc compiler or Sun Studio 9, and we would like to keep it that way unless it would be exceedingly involved. To ensure compatibility, please don't use any additional C99 features or gcc extensions. Watch out especially for:

- mixing statements and declarations;
- ``long long'` (use ``int64_t'` instead);
- ``__attribute__'` not protected by ``#ifdef __GNUC__'` or similar;
- gcc statement expressions (``(x = ({ int y = 4; y; })'`).

Indent size is 4. The TAB character should not be used. The presentation is the one specified by 'indent -i4 -kr'.

Main priority in ffmpeg is simplicity and small code size (=less bugs).

Comments: for functions visible from other modules, use the JavaDoc format (see examples in ``libav/utils.c'`) so that a documentation can be generated automatically.

fprintf and printf are forbidden in libavformat and libavcodec, please use av_log() instead.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.4 Submitting patches

When you submit your patch, try to send a unified diff (diff '-up' option). I cannot read other diffs :-)

Run the regression tests before submitting a patch so that you can verify that there are no big problems.

Patches should be posted as base64 encoded attachments (or any other encoding which ensures that the patch wont be trashed during transmission) to the ffmpeg-devel mailinglist, see http://lists.sourceforge.net/lists/listinfo/ffmpeg-devel

It also helps quite a bit if you tell us what the patch does (for example 'replaces lrint by lrintf') , and why (for example '*bsd isnt c99 compliant and has no lrint()')

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.5 Regression tests

Before submitting a patch (or committing with CVS), you should at least test that you did not break anything.

The regression test build a synthetic video stream and a synthetic audio stream. Then these are encoded then decoded with all codecs or formats. The CRC (or MD5) of each generated file is recorded in a result file. Then a 'diff' is launched with the reference results and the result file.

The regression test then goes on to test the ffserver code with a limited set of streams. It is important that this step runs correctly as well.

Run 'make test' to test all the codecs and formats.

Run 'make fulltest' to test all the codecs, formats and ffserver.

[Of course, some patches may change the regression tests results. In this case, the regression tests reference results shall be modified accordingly].

[Top] | [Contents] | [Index] | [ ? ]

# About This Document

This document was generated by Charlie & on October, 12 2005 using texi2html 1.76.

The buttons in the navigation panels have the following meaning:

Button | Name | Go to | From 1.2.3 go to
--- | --- | --- | ---
[ < ] | Back | previous section in reading order | 1.2.2
[ > ] | Forward | next section in reading order | 1.2.4
[ << ] | FastBack | beginning of this chapter or previous chapter | 1
[ Up ] | Up | up section | 1.2
[ >> ] | FastForward | next chapter | 2
[Top] | Top | cover (top) of document |
[Contents] | Contents | table of contents |
[Index] | Index | index |
[ ? ] | About | about (help) |

where the Example assumes that the current position is at Subsubsection One-Two-Three of a document of the following structure:

- 1. Section One
  - 1.1 Subsection One-One
    - ...
  - 1.2 Subsection One-Two
    - 1.2.1 Subsubsection One-Two-One
    - 1.2.2 Subsubsection One-Two-Two
    - 1.2.3 Subsubsection One-Two-Three <== Current Position
    - 1.2.4 Subsubsection One-Two-Four
  - 1.3 Subsection One-Three
    - ...
  - 1.4 Subsection One-Four

This document was generated by Charlie & on October, 12 2005 using texi2html 1.76.